# -*- coding: utf-8 -*
import os,sys
try:
    import configparser
except:
    import ConfigParser
from Log.Logger import log2File
from imp import reload

try:
    reload(sys)
    sys.setdefaultencoding('utf-8') # Python 2.x
except:
    pass

class IniParser(object):
    def __init__(self, path):
        try:
            self.cf = ConfigParser.RawConfigParser()
        except:
            self.cf = configparser.RawConfigParser()
        self.path = path

    def initconf(self):
        self.cf.read(self.path)

    def get(self, field, key):
        result = ""
        try:
            result = self.cf.get(field, key)
        except Exception as e:
            log2File('get section [%s] key [%s] in [%s] failed, error=%s' % (str(field), key, self.path, str(e.message)))
            result = ""
        return result

    def set(self, field, key, value):
        try:
            if not self.cf.has_section(field):
                self.cf.add_section(field)
            self.cf.set(field, key, value)
            self.cf.write(open(self.path, 'w'))
        except  Exception as e:
            log2File('set section [%s] key [%s] value [%s] in [%s] failed, error=%s' % (str(field), key, value, self.path, str(e.message)))
            return False
        return True
