#-*- coding: utf-8 -*
import platform
import os, sys, shutil, zipfile
pyVer = platform.python_version()
cabpath = os.path.join(os.path.dirname(os.path.abspath(__file__)),"cabarchive")
if os.path.exists(cabpath):
    shutil.rmtree(cabpath)

if pyVer.startswith("2."):
    cab2 = os.path.join(os.path.dirname(os.path.abspath(__file__)), "pycab","cabarchive2.zip")
    if os.path.exists(cab2):
        fz = zipfile.ZipFile(cab2, 'r')
        for file in fz.namelist():
            fz.extract(file, cabpath)
elif pyVer.startswith("3."):
    cab3 = os.path.join(os.path.dirname(os.path.abspath(__file__)), "pycab","cabarchive3.zip")
    if os.path.exists(cab3):
        fz = zipfile.ZipFile(cab3, 'r')
        for file in fz.namelist():
            fz.extract(file, cabpath)


import Modules.ModuleMgr
import FileUtiles.FileMgr
import Log
from Log.Logger import log2File
def exitUpdate(code):
    log2File("update status:" + str(code))
    log2File("=============end offline update===========")
    exit(code)
def userVerify():
    if os.geteuid() != 0:
        print("This program must be run as root. Aborting.")
        exit(1)

if __name__ == "__main__":
    code = 1
    userVerify()
    if len(sys.argv) != 2:
        print("Usage: python offlineupdate.py update_data_path")
        exit(1)
    install_dir = os.getcwd()
    if not os.path.exists(os.path.join(install_dir, 'OfflineUpdate')):
        install_dir = os.path.abspath('..')
        if not os.path.exists(os.path.join(install_dir, 'OfflineUpdate')):
            print("qaxsafe is not installed")
            exit(1)
    try:
        Log.Logger.install_dir = os.path.join(install_dir, 'Log')
    except Exception as e:
        print("init log failed, install dir: %s, err: %s" % (install_dir, str(e)))
        exit(1)
    log2File("=============start offline update===========")
    update_data_dir = sys.argv[1]
    update_data  = os.path.join(update_data_dir, 'inst/update')
    isFound = False
    if os.path.exists(update_data):
        log2File("find update_data inst/update")
        isFound = True
    else:
        log2File("not find update_data inst/update")
        dirs = os.listdir(update_data_dir)
        for file in dirs:
            subzip = os.path.join(update_data_dir, file)
            if subzip.endswith(".zip") and zipfile.is_zipfile(subzip):
                if file.startswith("engine_{}".format(2*180)) or file.startswith("engine_qax"):
                    log2File("find zip archive")
                    isFound = True
                if isFound:
                    try:
                        module = file.split('.')[0]
                        zipf = zipfile.ZipFile(subzip)
                        extractdir = os.path.join(update_data_dir, module)
                        zipf.extractall(extractdir)
                        update_data = update_data_dir
                    except Exception as e:
                        log2File(subzip + ' unpack fail:'  + e.message)
                        exitUpdate(code)

    if not isFound:
        log2File(update_data + ' or zip is not exist.')
        exitUpdate(code)

    moduleParser = Modules.ModuleMgr.ModuleParser(install_dir)
    module_list = moduleParser.get_module_list()
    if not module_list:
        log2File("module list is empty.")
        exitUpdate(code)
    tmp_update_dir = os.path.join(install_dir, 'OfflineUpdate/tmpupdate')
    try:
        if os.path.exists(tmp_update_dir):
            shutil.rmtree(tmp_update_dir)
        os.mkdir(tmp_update_dir)
    except IOError as e:
        log2File(tmp_update_dir + ' create fail because ' + e.message)
        exitUpdate(code)

    updatecfg_conf = os.path.join(install_dir, 'updatecfg.ini')
    tmp_updatecfg_conf = os.path.join(tmp_update_dir, 'updatecfg_tmp.ini')
    if os.path.exists(updatecfg_conf):
        shutil.copy(updatecfg_conf, tmp_updatecfg_conf)
    else:
        fd = open(tmp_updatecfg_conf, 'w')
        fd.close()
    module_dat = os.path.join(install_dir, 'Data/asmodularize.dat')
    tmp_module_dat = os.path.join(tmp_update_dir, 'asmodularize_tmp.dat')

    fileMgr = FileUtiles.FileMgr.FileMgr(install_dir, update_data, tmp_update_dir, tmp_updatecfg_conf, tmp_module_dat)

    if os.path.exists(module_dat):
        shutil.copy(module_dat, tmp_module_dat)
    else:
        log2File(module_dat + " is not exists.")
        fileMgr.emptyTmpData()
        exitUpdate(code)
    for module in module_list:
        res = fileMgr.update(module)
        if res == False:
            fileMgr.rollback()
            fileMgr.emptyTmpData()
            exitUpdate(code)

    fileMgr.endUpdate()
    fileMgr.emptyTmpData()
    #fileMgr.rebootService()
    if fileMgr.isupdate:
        code = 100
    else:
        code = 0
    exitUpdate(code)
